#include <vdi.h>

void SetVDIPB(VDIPB *vdipb);


void SetVDIPB(VDIPB *vdipb)
{
	vdipb->contrl	=_VDIParBlk.contrl;
	vdipb->intin	=_VDIParBlk.intin;
	vdipb->intout	=_VDIParBlk.intout;
	vdipb->ptsin	=_VDIParBlk.ptsin;
	vdipb->ptsout	=_VDIParBlk.ptsout;
}

int vmid_load(int handle,char *fname,unsigned long position)
{
	int i;
	VDIPB vdipb;
	SetVDIPB(&vdipb);
	(vdipb.intout)[0]=0;
	(vdipb.contrl)[0]=5;
	(vdipb.contrl)[1]=0;
	(vdipb.contrl)[5]=4000;
	(vdipb.contrl)[6]=handle;
	((unsigned long *)(vdipb.intin))[0]=position;
	i=0;
	while(fname[i])
	{
		(vdipb.intin)[i+2]=(int)fname[i];
		i++;
	}	
	(vdipb.contrl)[3]=i+2;	
	vdi(&vdipb);
	return (vdipb.intout)[0];
}

void vmid_unload(int handle)
{
	VDIPB vdipb;
	SetVDIPB(&vdipb);
	(vdipb.intout)[0]=0;
	(vdipb.contrl)[0]=5;
	(vdipb.contrl)[1]=0;
	(vdipb.contrl)[3]=0;	
	(vdipb.contrl)[5]=4001;
	(vdipb.contrl)[6]=handle;
	vdi(&vdipb);
}

void vmid_play(int handle)
{
	VDIPB vdipb;
	SetVDIPB(&vdipb);
	(vdipb.intout)[0]=0;
	(vdipb.contrl)[0]=5;
	(vdipb.contrl)[1]=0;
	(vdipb.contrl)[3]=0;
	(vdipb.contrl)[5]=4002;
	(vdipb.contrl)[6]=handle;
	vdi(&vdipb);
}


/********************************************************************************/
/*	binding PURE C								*/
/*										*/
/*	int vq_driver_info(int handle, char name[27]) 				*/
/*										*/
/*	Retour: 0 si l'appel est inhexistant					*/
/*										*/
/********************************************************************************/

int vq_driver_name(int handle,char name[27])
{
	int i;
	VDIPB vdipb;
	vdipb.contrl	=_VDIParBlk.contrl;
	vdipb.intin	=_VDIParBlk.intin;
	vdipb.intout	=_VDIParBlk.intout;
	vdipb.ptsin	=_VDIParBlk.ptsin;
	vdipb.ptsout	=_VDIParBlk.ptsout;
	(vdipb.intout)[0]=0;
	(vdipb.contrl)[0]=5;    
	(vdipb.contrl)[1]=0;
	(vdipb.contrl)[3]=0;
	(vdipb.contrl)[5]=2108;
	(vdipb.contrl)[6]=handle;	
	vdi(&vdipb);
	for(i=0;i<26;i++)
		*name++=(vdipb.intout)[i];
	*name=0;
	return ((vdipb.intout)[0]);
}

/********************************************************************************/
/*	binding PURE C																*/
/*																				*/
/*	int vq_driver_info(int handle,int *res0, int *drv, int *res1, *int res2, char name[27]) */
/*																				*/
/*	Retour: 0 si l'appel est inhexistant										*/
/*		drv contient le no du driver						 					*/
/*		res0,res1,res2: reservs												*/
/*																				*/
/********************************************************************************/

int vq_driver_info(int handle,int *res0,int *drv,int *res1,int *res2, char name[27])
{
	int i;
	VDIPB vdipb;
	SetVDIPB(&vdipb);
	(vdipb.intout)[0]=0;
	(vdipb.contrl)[0]=5;    
	(vdipb.contrl)[1]=0;
	(vdipb.contrl)[3]=0;
	(vdipb.contrl)[5]=2101;
	(vdipb.contrl)[6]=handle;	
	vdi(&vdipb);
	*res0=(vdipb.intout)[1];
	*drv=(vdipb.intout)[2];
	*res1=(vdipb.intout)[3];
	*res2=(vdipb.intout)[4];	
	for(i=0;i<26;i++)
	{
		*name++=(vdipb.intout)[i+5];
	}
	*name=0;
	return ((vdipb.intout)[0]);
}
